/*
 * Copyright (C) 2017  Fluence Labs Limited
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package fluence.crypto.facade.ed25519

import io.scalajs.nodejs.buffer.Buffer

import scala.scalajs.js
import scala.scalajs.js.annotation.JSImport

@js.native
trait KeyPair extends js.Object {
  val publicKey: Buffer
  val secretKey: Buffer
}

@js.native
@JSImport("supercop.js", JSImport.Namespace)
object Supercop extends js.Object {
  def verify(sig: Buffer, msg: Buffer, pubKey: Buffer): Boolean = js.native
  def sign(msg: Buffer, pubKey: Buffer, privKey: Buffer): Buffer = js.native
  def createKeyPair(seed: Buffer): KeyPair = js.native
  def createSeed(): Buffer = js.native
}
